
SLASH_SIMPLERECRUITMENT1, SLASH_SIMPLERECRUITMENT2 = '/sr', '/simplerecruitment';

-- by Kaemin

function SlashCmdList.SIMPLERECRUITMENT(msg, editbox)
	SimpleRecruitment_LoadSecondarySettings();
	SimpleRecruitment_MenuUpdateText();
	if msg == nil or msg == "" or msg == "menu" or msg == "options" or msg == "?" or msg == "help" then
		InterfaceOptionsFrame_OpenToCategory(SimpleRecruitment_PanelName);
		InterfaceOptionsFrame_OpenToCategory(SimpleRecruitment_PanelName);
		SimpleRecruitmentDisclaimerA:SetText(SimpleRecruitment_DisclaimerA);
		SimpleRecruitmentDisclaimerB:SetText(SimpleRecruitment_DisclaimerB);
		SimpleRecruitmentDisclaimerD:SetText("The box to the right contains the names of players who have whispered you\nback after using this addon to whisper them. When you click a name, it will\npresent the players name in the editbox under the list.\n\nClick the editbox to highlight the name, then use ctrl+c to copy the name,\nthen ctrl+v to paste it into a whisper or /guildinvite.");
		SimpleRecruitment_MenuUpdateText();
	elseif msg == "scan" then
		SimpleRecruitment_ScanOrNot = true;
		SimpleRecruitment_ScanCheck();
	elseif msg == "list" then
		SimpleRecruitment_RecWhisperList();
	else
		DEFAULT_CHAT_FRAME:AddMessage("SimpleRecruitment " ..GetAddOnMetadata("SimpleRecruitment", "Version").. ": /sr for options.");
	end
end

function SimpleRecruitment_ScanCheck()
	SimpleRecruitment_CleanUpBlackList();
	SetWhoToUI(1);
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
	if guildName and (CanGuildInvite()) then
		SendWho(SimpleRecruitment_whoString);
		local numWhos = GetNumWhoResults();
		for index = 1, numWhos do local charname, guildname, level, race, class, zone, classFileName = GetWhoInfo(index);
			if (guildname == "") then
				for i = 1, #SimpleRecruitment_BlackList do
					local PlayerGuild, DayOfYear, WhisperTarget = strsplit(",", SimpleRecruitment_BlackList[i], 3);
					if PlayerGuild == guildName and WhisperTarget == charname and tonumber(DayOfYear) > (tonumber(SRDayOfTheYear)-30) then
						return
					end
				end
				if SimpleRecruitment_UseGreeting then
					if SimpleRecruitment_FilterSetOn then
						local filterFunc = ("Hello, "..charname.."! "..SimpleRecruitment_ActiveMessage);
						ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(self, event, msg)
							if strfind(msg, filterFunc) then
								return true
							end
						end)
					end
					SendChatMessage("Hello, "..charname.."! "..SimpleRecruitment_ActiveMessage, "WHISPER", nil, charname);
--					local SimpleRecruitment_PlayerSelf = UnitName("player"); SendChatMessage("Hello, "..charname.."! "..SimpleRecruitment_ActiveMessage, "WHISPER", nil, SimpleRecruitment_PlayerSelf);
				else
					if SimpleRecruitment_FilterSetOn then
						local filterFunc = SimpleRecruitment_ActiveMessage;
						ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(self, event, msg)
							if strfind(msg, filterFunc) then
								return true
							end
						end)
					SendChatMessage(SimpleRecruitment_ActiveMessage, "WHISPER", nil, charname);	
--					local SimpleRecruitment_PlayerSelf = UnitName("player"); SendChatMessage("TO "..charname..": "..SimpleRecruitment_ActiveMessage, "WHISPER", nil, SimpleRecruitment_PlayerSelf);
				end
				local infoText = ""..guildName..","..SRDayOfTheYear..","..charname.."";
				table.insert(SimpleRecruitment_BlackList, infoText);
				C_ChatInfo.SendAddonMessageLogged("SimpleRecruit", infoText, "GUILD");
				end
			end
		end
	end
	C_Timer.After(.35, function() HideUIPanel(FriendsFrame) end);
	SetWhoToUI(0);
end

function SimpleRecruitment_AddonMessageReceived(prefix, message)
	if string.find(message, "SyncRequest") then
		local syncRequest = true;
	else 
		local syncRequest = false;
	end
	if SimpleRecruitment_SyncThis and not syncRequest then
		if RecDayOfYear and tonumber(RecDayOfYear) < (tonumber (SRDayOfTheYear) -30) then
			return
		end
		for i = 1, #SimpleRecruitment_BlackList do
			local PlayerGuild, DayOfYear, WhisperTarget = strsplit(",", SimpleRecruitment_BlackList[i], 3);
			local RecPlayerGuild, RecDayOfYear, RecWhisperTarget = strsplit (",", message, 3);
			if PlayerGuild ~= RecPlayerGuild or WhisperTarget == RecWhisperTarget then
				return
			end
			if RecWhisperTarget then local infoText = ""..RecPlayerGuild.. "," ..RecDayOfYear.. "," ..RecWhisperTarget..""; end
			table.insert(SimpleRecruitment_BlackList, infoText);
		end
	else
		if SimpleRecruitment_SyncThis and syncRequest then 
			SimpleRecruitment_SendSyncBlackList(message);
		end
	end
end

function SimpleRecruitment_SendSyncBlackList(syncMessage)
	local sender, request = strsplit("-", syncMessage, 2);
	if sender == UnitName("player") then
		return
	end
	SimpleRecruitment_CleanUpBlackList();
	for i = 1, #SimpleRecruitment_BlackList do
		C_ChatInfo.SendAddonMessageLogged("SimpleRecruit", SimpleRecruitment_BlackList[i], "GUILD");
	end
end

function SimpleRecruitment_CleanUpBlackList()
	for i = 1, #SimpleRecruitment_BlackList do
		local PlayerGuild, DayOfYear, WhisperTarget = strsplit(",", SimpleRecruitment_BlackList[i], 3);
		if tonumber(DayOfYear) > tonumber(SRDayOfTheYear) then
			local srPreviousYear = (tonumber (SRDayOfTheYear) + 335);
			if tonumber(DayOfYear) < srPreviousYear then
				table.remove (SimpleRecruitment_BlackList, i);
			end
		end
		if tonumber(DayOfYear) < (tonumber(SRDayOfTheYear) -30) then
			table.remove (SimpleRecruitment_BlackList, i);
		end
	end
end

function SimpleRecruitment_CustomMessageEntered(MessageText)
	SimpleRecruitment_VariablesCustomMessage = MessageText;
	SimpleRecruitment_CurrentCustomMessage:SetText (MessageText);
end

function SimpleRecruitment_MenuUpdateText()
	if not SimpleRecruitment_VariablesCustomMessage or SimpleRecruitment_VariablesCustomMessage == "" then SimpleRecruitment_VariablesCustomMessage = ""; 
		SimpleRecruitment_MessageChoiceDefault:SetChecked(true);
		SimpleRecruitment_MessageCustomChoice:SetChecked(false);
		SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesDefaultMessage;
	end
	if not SimpleRecruitment_MessageChoiceDefault:GetChecked() and not SimpleRecruitment_MessageCustomChoice:GetChecked() then
		SimpleRecruitment_MessageChoiceDefault:SetChecked(true);
		SimpleRecruitment_MessageCustomChoice:SetChecked(false);
		SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesDefaultMessage;
	end
	SimpleRecruitment_CurrentCustomMessage:SetText (SimpleRecruitment_VariablesCustomMessage);
	SimpleRecruitment_CurrentDefaultMessage:SetText (SimpleRecruitment_VariablesDefaultMessage);
	if SimpleRecruitment_FilterSetOn then SimpleRecruitment_CheckFilter:SetChecked(true);
	else SimpleRecruitment_CheckFilter:SetChecked(false);
	end
	if SimpleRecruitment_UseGreeting then SimpleRecruitment_UseGreetingCheck:SetChecked(true);
	else SimpleRecruitment_UseGreetingCheck:SetChecked(false);
	end	
end

function SimpleRecruitment_MessageCustomButton()
	SimpleRecruitment_MessageCustomChoice:SetScript("PostClick", function(self)
		if not SimpleRecruitment_VariablesCustomMessage or SimpleRecruitment_VariablesCustomMessage == "" then
			SimpleRecruitment_MessageChoiceDefault:SetChecked(true);
			SimpleRecruitment_MessageCustomChoice:SetChecked(false);
			SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesDefaultMessage;
		else
			SimpleRecruitment_MessageChoiceDefault:SetChecked(false);
			SimpleRecruitment_MessageCustomChoice:SetChecked(true);
			SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesCustomMessage;
		end
	end)
end

function SimpleRecruitment_MessageDefaultButton()
	SimpleRecruitment_MessageChoiceDefault:SetScript("PostClick", function(self)
		SimpleRecruitment_MessageChoiceDefault:SetChecked(true);
		SimpleRecruitment_MessageCustomChoice:SetChecked(false);
		SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesDefaultMessage;
	end)
end

function SimpleRecruitment_ClearCustomMessageButton()
	SimpleRecruitment_MessageEditBox:SetText("");
	SimpleRecruitment_MessageEditBox:ClearFocus();
end

function SimpleRecruitment_SaveCustomMessageButton()
	local SimpleRecruitment_SetCustomText = SimpleRecruitment_MessageEditBox:GetText();
	if SimpleRecruitment_SetCustomText ~= "" then
		SimpleRecruitment_CustomMessageEntered(SimpleRecruitment_SetCustomText);
	end
	SimpleRecruitment_MessageEditBox:SetText("");
	SimpleRecruitment_MessageChoiceDefault:SetChecked(false);
	SimpleRecruitment_MessageCustomChoice:SetChecked(true);
	SimpleRecruitment_MessageEditBox:ClearFocus();
	SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesCustomMessage;
end

function SimpleRecruitment_DeleteCustomMessageButton()
	SimpleRecruitment_SetCustomText = "";
	SimpleRecruitment_CustomMessageEntered(SimpleRecruitment_SetCustomText);
	SimpleRecruitment_MessageChoiceDefault:SetChecked(true);
	SimpleRecruitment_MessageCustomChoice:SetChecked(false);
	SimpleRecruitment_MessageEditBox:ClearFocus();
	SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesDefaultMessage;
end

function SimpleRecruitment_CheckFilterMessage()
	SimpleRecruitment_CheckFilter:SetScript("PostClick", function(self)
		if self:GetChecked() then
			SimpleRecruitment_FilterSetOn = true;
		else
			SimpleRecruitment_FilterSetOn = false;
		end
	end)
	ReloadUI();
end

function SimpleRecruitment_UseMessageGreeting()
	SimpleRecruitment_UseGreetingCheck:SetScript("PostClick", function(self)
		if self:GetChecked() then
			SimpleRecruitment_UseGreeting = true;
		else
			SimpleRecruitment_UseGreeting = false;
		end
	end)
end

function SimpleRecruitment_MenuPanel(SimpleRecruitment_Panel)
	SimpleRecruitment_Panel.name = "SimpleRecruitment " ..GetAddOnMetadata("SimpleRecruitment", "Version");
	SimpleRecruitment_Panel.okay = function (self) SimpleRecruitment_MenuPanel_Close(); end;
    SimpleRecruitment_Panel.cancel = function (self) SimpleRecruitment_MenuPanel_CancelOrLoad(); end;
	SimpleRecruitmentDisclaimerA:SetText(SimpleRecruitment_DisclaimerA);
	SimpleRecruitmentDisclaimerB:SetText(SimpleRecruitment_DisclaimerB);
	MessageMenuHeader:SetText   ("Message Options");
	DisclaimerMenuHeader:SetText("Disclaimer");
	SettingsMenuHeader:SetText  ("Settings");
	InterfaceOptions_AddCategory(SimpleRecruitment_Panel);
end

function SimpleRecruitment_MenuPanel_Close()
	SimpleRecruitment_MessageEditBox:SetText("");
	if SROptions_Frame:IsShown() then
		SROptions_Frame:Hide();
	end
end

function SimpleRecruitment_MenuPanel_CancelOrLoad()
	SimpleRecruitment_MessageEditBox:SetText("");
	if SROptions_Frame:IsShown() then
		SROptions_Frame:Hide();
	end
end

function SimpleRecruitment_WhisperReceived(whisperName, whisperMessage)
	for i = 1, #SimpleRecruitment_BlackList do
		local PlayerGuild, DayOfYear, WhisperTarget = strsplit(",", SimpleRecruitment_BlackList[i], 3);
		if DayOfYear then 
			if tonumber(DayOfYear) >= (tonumber(SRDayOfTheYear) -1) and WhisperTarget == whisperName then
				SimpleRecruitment_WhisperSendReturned(whisperName, DayOfYear);
			end
		end
	end
end

function SimpleRecruitment_WhisperSendReturned(whisperWhen, whisperName)
	local infoText = ""..whisperWhen..","..whisperName.."";
	table.insert (SimpleRecruitment_RecWhisperList, infoText);
	SimpleRecruitment_CleanWhisperList();
	SimpleRecruitment_WhisperList_OnLoad();
	SimpleRecruitment_WhisperListScrollBar_Update();
end

function SimpleRecruitment_CleanWhisperList()
	for i = 1, #SimpleRecruitment_RecWhisperList do
		local DayOfYear, WhisperTarget = strsplit(",", SimpleRecruitment_RecWhisperList[i], 2);
		if tonumber(DayOfYear) < (tonumber(SRDayOfTheYear) -1) then
			table.remove (SimpleRecruitment_RecWhisperList, i);
		end
	end
end

function SimpleRecruitment_ClearListButton()
	for i = 1, #SimpleRecruitment_RecWhisperList do
		table.remove (SimpleRecruitment_RecWhisperList, i);
	end
	for i = 1, 50 do
		SimpleRecruitment_WhisperList[i] = nil;
	end
	SimpleRecruitment_WhisperListScrollBar_Update();
end

function SimpleRecruitment_WhisperList_OnLoad()
-- DEBUG
--	for i = 1, 52 do
--		local testThis = "Testthis  "..i;
--		SimpleRecruitment_WhisperList[i] = testThis
--	end
-- END DEBUG
	if SimpleRecruitment_RecWhisperList then
		for i = 1, #SimpleRecruitment_RecWhisperList do
			local DayOfYear, WhisperTarget = strsplit(",", SimpleRecruitment_RecWhisperList[i], 2);
			SimpleRecruitment_WhisperList[i] = WhisperTarget;
		end
	SimpleRecruitment_WhisperListScrollBar:Show()
	end
end

function SimpleRecruitment_WhisperListScrollBar_Update()
	local line;
	local lineplusoffset;
	FauxScrollFrame_Update(SimpleRecruitment_WhisperListScrollBar,50,5,16);
	for line=1,7 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(SimpleRecruitment_WhisperListScrollBar);
		if lineplusoffset <= 50 then
			getglobal("SimpleRecruitment_WhisperListEntry"..line):SetText(SimpleRecruitment_WhisperList[lineplusoffset]);
			getglobal("SimpleRecruitment_WhisperListEntry"..line):Show();
		else
			getglobal("SimpleRecruitment_WhisperListEntry"..line):Hide();
		end
	end
end

function SimpleRecruitment_NameInsertEditBox(whichButton)
	if not whichButton then
		return
	end
	if whichButton == 1
		then local buttonText = SimpleRecruitment_WhisperListEntry1:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	elseif whichButton == 2
		then local buttonText = SimpleRecruitment_WhisperListEntry2:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	elseif whichButton == 3
		then local buttonText = SimpleRecruitment_WhisperListEntry3:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	elseif whichButton == 4
		then local buttonText = SimpleRecruitment_WhisperListEntry4:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	elseif whichButton == 5
		then local buttonText = SimpleRecruitment_WhisperListEntry5:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	elseif whichButton == 6
		then local buttonText = SimpleRecruitment_WhisperListEntry6:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	elseif whichButton == 7
		then local buttonText = SimpleRecruitment_WhisperListEntry7:GetText();
		SimpleRecruitment_EditBox:SetText(buttonText);
	end
end

function SimpleRecruitment_LoadSettings()
	SimpleRecruitment_TodayLocalYear = date("%y"); SimpleRecruitment_TodayLocalMonth = date("%m"); SimpleRecruitment_TodayLocalDay = date("%d");
	if not SimpleRecruitment_whoString then SimpleRecruitment_whoString = ""; end;
	if not SimpleRecruitment_FilterSetOn then SimpleRecruitment_FilterSetOn = true; end
	if not SimpleRecruitment_SyncThis then SimpleRecruitment_SyncThis = true; end
	if not SimpleRecruitment_UseGreeting then SimpleRecruitment_UseGreeting = false; end
	if not SimpleRecruitment_DisclaimerA then SimpleRecruitment_DisclaimerA = "This addon is only to be used as a tool to increase guild population in struggling guilds."; end
	if not SimpleRecruitment_DisclaimerB then SimpleRecruitment_DisclaimerB = "This addon may get your account suspended or banned if abused in any way."; end
	if not SimpleRecruitment_MenuMessageHeader then SimpleRecruitment_MenuMessageHeader = "Message Options"; end
	SimpleRecruitment_CheckFilter.tooltip = "Requires reload";
	SimpleRecruitment_sucessfulRequest = C_ChatInfo.RegisterAddonMessagePrefix("SimpleRecruit")
	if not SimpleRecruitment_WhisperList then SimpleRecruitment_WhisperList = {}; end
end

function SimpleRecruitment_LoadSecondarySettings()
	if (IsInGuild()) then
		SimpleRecruitment_VariablesPlayerInGuild = "true";
		local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
			SimpleRecruitment_VariablesPlayerGuildName = guildName;
	else
		SimpleRecruitment_VariablesPlayerInGuild = "false";
	end
	if (CanGuildInvite()) then
		SimpleRecruitment_VariablesPlayerCanInvite = "true";
	else
		SimpleRecruitment_VariablesPlayerCanInvite = "false";
	end
	if not SimpleRecruitment_VariablesPlayerGuildName and SimpleRecruitment_VariablesPlayerInGuild == "true" then 
		local guildName, guildRankName, guildRankIndex = GetGuildInfo("Player");
			SimpleRecruitment_VariablesPlayerGuildName = guildName;
	end
	if not SimpleRecruitment_VariablesDefaultMessage then
		SimpleRecruitment_VariablesDefaultMessage = ("<" ..SimpleRecruitment_VariablesPlayerGuildName.. "> is now recruiting! All classes, all levels welcome. Please whisper me for details."); 
	end
	if not SimpleRecruitment_ActiveMessage then SimpleRecruitment_ActiveMessage = SimpleRecruitment_VariablesDefaultMessage; end
	local year = tonumber(SimpleRecruitment_TodayLocalYear);
	local month = tonumber(SimpleRecruitment_TodayLocalMonth);
	local day = tonumber(SimpleRecruitment_TodayLocalDay);
	local N1 = floor(275 * month / 9);
	local N2 = floor((month + 9) / 12);
	local N3 = (1 + floor((year - 4 * floor(year / 4) + 2) / 3));
	local N = N1 - (N2 * N3) + day - 30;
	SRDayOfTheYear = N;
	if type(SimpleRecruitment_BlackList) ~= "table" then
		SimpleRecruitment_BlackList = {};
	end
	SetWhoToUI(1);
	SendWho("");
	C_Timer.After(.3, function() HideUIPanel(FriendsFrame) end);
	SetWhoToUI(0);
	local name, realm = UnitName("player");
	C_ChatInfo.SendAddonMessageLogged("SimpleRecruit", ""..name.."-SyncRequest", "GUILD");
	SimpleRecruitment_WhisperList_OnLoad();
end

function SimpleRecruitment_OnLoad(SimpleRecruitment_Panel)
	local fframe = CreateFrame("Frame")
	fframe:RegisterEvent("ADDON_LOADED");
	fframe:RegisterEvent("PLAYER_LOGIN");
	fframe:RegisterEvent("CHAT_MSG_ADDON_LOGGED");
	fframe:RegisterEvent("CHAT_MSG_WHISPER");
	fframe:SetScript("OnEvent", function(self, event, arg1, arg2)
		if event == "ADDON_LOADED" and arg1 == "SimpleRecruitment" then
			SROptions_Frame:SetScale(.75);
			if not SimpleRecruitment_RecWhisperList or SimpleRecruitment_RecWhisperList == "" then SimpleRecruitment_RecWhisperList = {}; end
		end
		if event == "PLAYER_LOGIN" then
			if type(SimpleRecruitment_BlackList) ~= "table" then
				SimpleRecruitment_BlackList = {};
			end
			SetWhoToUI(1);
			SendWho("");
			C_Timer.After(.3, function() HideUIPanel(FriendsFrame) end);
			SetWhoToUI(0);
		end
		if event == "CHAT_MSG_ADDON_LOGGED" then
			SimpleRecruitment_AddonMessageReceived(arg1, arg2);
		end
		if event == ("CHAT_MSG_WHISPER") then
			SimpleRecruitment_WhisperReceived(arg1, arg2);
		end
	end)
	SROptions_Frame:Hide();
	SimpleRecruitment_PanelName = SimpleRecruitment_Panel
	SimpleRecruitment_MenuPanel(SimpleRecruitment_Panel);
	SimpleRecruitment_LoadSettings();
	if SimpleRecruitment_sucessfulRequest then 
		SimpleRecruitment_SyncInfo = "Sync ENABLED:" 
	else 
		SimpleRecruitment_SyncInfo = "Sync DISABLED:";
	end
	DEFAULT_CHAT_FRAME:AddMessage("SimpleRecruitment " ..GetAddOnMetadata("SimpleRecruitment", "Version").. " loaded, "..SimpleRecruitment_SyncInfo.." /sr for options");
end
